<?php

namespace netico\Bones;

class Template
{
    private $blocks;
    private $vars;
    private $nblocks;
    private $template;

    public function __construct($template)
    {

        $this->template = $template;
        $this->nblocks = array();
        $this->blocks = array();
        $this->vars = array();
    }

    public function load()
    {

        $vart = $this->template;

        $varfd = fopen("$vart", "r");
        $varc = fread($varfd, filesize("$vart"));
        fclose($varfd);

        return $varc;
    }

    private function __add($key, $value, $content)
    {

        $pattern = '/{' . preg_quote($key, '/') . '}/';

        return preg_replace($pattern, $value, $content);
    }

    public function add($key, $value)
    {
        $varm = array();
        if (preg_match("/" . preg_quote('.', '/') . "/s", $key, $varm) > 0) {
            $vara = preg_split("/" . preg_quote('.', '/') . "/s", $key);

            $varc = $vara[0];
            $vard = $vara[1];

            $iter = $this->iter;

            $this->nblocks["$varc"][$iter]["$vard"] = array("key" => "$vard", "value" => "$value");
        }


        if (preg_match("/" . preg_quote('.', '/') . "/s", $key, $varm) < 1) {
            $this->vars["$key"]["key"] = $key;
            $this->vars["$key"]["value"] = $value;
        }
    }

    public function block($key)
    {

        $varc = $this->load();

        $pcre1 = "/" . preg_quote('<!-- start(', '/') . $key . preg_quote(') -->', '/') . "/si";
        $pcre2 = "/" . preg_quote('<!-- end(', '/') . $key . preg_quote(') -->', '/') . "/si";

        $vara = preg_split($pcre1, $varc);

        $varc = $vara[1];

        $vara = preg_split($pcre2, $varc);

        if (empty($this->blocks["$key"]) == true) {
            $iter = 0;
        }

        if (empty($this->blocks["$key"]) == false) {
            $iter = $this->iter;
        }
        $str = '<!-- start(' . $key . ') -->';
        $str = $vara[0];
        $str .= '<!-- end(' . $key . ') -->';

        $this->blocks["$key"]["content"] = $str;

        $this->iter = ($iter + 1);
    }

    public function string()
    {
        ksort($this->blocks);
        ksort($this->nblocks);

        $new_contents = array();

        foreach ($this->nblocks as $k => $r) {
            $content = $this->blocks["$k"]["content"];
            $new_content = "\n\n<!-- block $k -->\n\n";

            // REPETITIONS
            foreach ($r as $repetition => $repetition_array) {
                $tmp = $content;

                // BLOCK
                foreach ($repetition_array as $key => $key_array) {
                    $pcre = $key_array["key"];
                    $value = $key_array["value"];

                    if (empty($pcre) != true && empty($value) != true) {
                        $tmp = $this->__add($pcre, $value, $tmp);
                    }
                }

                unset($key);
                $new_content .= $tmp;
            }
            unset($repetition);

            $new_content .= "\n\n<!-- end block -->\n\n";

            $new_contents["$k"]["content"] = $new_content;
        }

        $text = $this->load();

        foreach ($new_contents as $k => $v) {
            $content = $this->blocks["$k"]["content"];
            $content = '/' . preg_quote($content, '/') . '/';

            $new_content = $v["content"];

            $text = preg_replace($content, $new_content, $text);
        }

        foreach ($this->vars as $k => $v) {
            $pcre = $v["key"];
            $value = $v["value"];

            $text = $this->__add($pcre, $value, $text);
        }

        return $text;
    }

    public function output($mime)
    {
        switch ($mime) {
            case 'HTML':
            default:
                header('Content-Type: text/html');
                $a = preg_replace('/<!--(.*)-->/Uis', '', $this->string());
                $b = preg_replace("/(^[\r\n]*|[\r\n]+)[\s\t]*[\r\n]+/", "\n", $a);
                print $b;
                break;
        }
    }
}
