<?php

namespace netico\Bones;

class Configuration
{
    private $res;
    public $version = "0.3.1";
    private $parsed;

    public function __construct()
    {
        $this->res = array();
        $this->parsed = $this->parser(CONFIG);
    }
    
    public function parser($filename)
    {

        if (is_readable($filename)) {
            $section = "";
            $fdo = @fopen($filename, "r");
            while (feof($fdo) != true) {
                $line = trim(fgets($fdo, 4096));
                $len = strlen($line);
                if ($len != 0 && $line[0] != ';' && $line[0] === '[' && $line[$len - 1] === ']') {
                    $section = substr($line, 1, $len - 2);
                }
                $pos = strpos($line, '=');
                if ($pos > 0 && $section != "") {
                    $name = trim(substr($line, 0, $pos));
                    $value = trim(substr($line, $pos + 1, $len - $pos - 1));
                    $value = str_replace('"', '\\"', $value);
                    $value = str_replace("\"", '\\\'', $value);
                    $this->res["$section"]["$name"] = $value;
                }
            }
            fclose($fdo);
        }
        return $this->res;
    }
    
    public function getValue($section, $name)
    {
        foreach ($this->parsed as $i => $a) {
            $b =  array();
            $b = $a;
            foreach ($b as $n => $v) {
                if (strcmp($i, $section) == 0 && strcmp($n, $name) == 0) {
                    return $v;
                }
            }
        }
        return '';
    }
}
