Search.appendIndex(
    [
                {
            "fqsen": "\\netico\\Bones\\Configuration",
            "name": "Configuration",
            "summary": "The\u0020Configuration\u0020class\u0020retrieves\u0020configuration\u0020variables\u0020from\u0020an\u0020.ini\u0020file.",
            "url": "classes/netico-Bones-Configuration.html"
        },                {
            "fqsen": "\\netico\\Bones\\Configuration\u003A\u003A__construct\u0028\u0029",
            "name": "__construct",
            "summary": "This\u0020code\u0020works\u0020if\u0020you\u0020set\u0020the\u0020CONFIG\u0020constant.",
            "url": "classes/netico-Bones-Configuration.html#method___construct"
        },                {
            "fqsen": "\\netico\\Bones\\Configuration\u003A\u003AgetValue\u0028\u0029",
            "name": "getValue",
            "summary": "This\u0020method\u0020gets\u0020a\u0020configuration\u0020option.",
            "url": "classes/netico-Bones-Configuration.html#method_getValue"
        },                {
            "fqsen": "\\netico\\Bones\\Obfuscation",
            "name": "Obfuscation",
            "summary": "String\u0020obfuscation.",
            "url": "classes/netico-Bones-Obfuscation.html"
        },                {
            "fqsen": "\\netico\\Bones\\Obfuscation\u003A\u003Aobfuscate\u0028\u0029",
            "name": "obfuscate",
            "summary": "This\u0020is\u0020the\u0020method\u0020to\u0020obfuscate\u0020a\u0020string.",
            "url": "classes/netico-Bones-Obfuscation.html#method_obfuscate"
        },                {
            "fqsen": "\\netico\\Bones\\Obfuscation\u003A\u003Adeobfuscate\u0028\u0029",
            "name": "deobfuscate",
            "summary": "This\u0020is\u0020the\u0020method\u0020to\u0020deobfuscate\u0020a\u0020string.",
            "url": "classes/netico-Bones-Obfuscation.html#method_deobfuscate"
        },                {
            "fqsen": "\\netico\\Bones\\SQLite",
            "name": "SQLite",
            "summary": "SQLite\u0020wrapper.",
            "url": "classes/netico-Bones-SQLite.html"
        },                {
            "fqsen": "\\netico\\Bones\\SQLite\u003A\u003A__construct\u0028\u0029",
            "name": "__construct",
            "summary": "This\u0020method\u0020retrieves\u0020the\u0020SQLite\u0020database\u0020path\u0020from\u0020the\u0020configuration\u0020file\nand\u0020then\u0020opens\u0020a\u0020connection\u0020in\u0020read\u0020mode.",
            "url": "classes/netico-Bones-SQLite.html#method___construct"
        },                {
            "fqsen": "\\netico\\Bones\\SQLite\u003A\u003Aclose\u0028\u0029",
            "name": "close",
            "summary": "This\u0020method\u0020closes\u0020the\u0020connection\u0020to\u0020the\u0020database.",
            "url": "classes/netico-Bones-SQLite.html#method_close"
        },                {
            "fqsen": "\\netico\\Bones\\SQLite\u003A\u003ASQL\u0028\u0029",
            "name": "SQL",
            "summary": "It\u0020runs\u0020a\u0020SQL\u0020query\u0020on\u0020a\u0020given\u0020database\u0020and\u0020builds\u0020an\u0020array\u0020of\u0020the\u0020results.",
            "url": "classes/netico-Bones-SQLite.html#method_SQL"
        },                {
            "fqsen": "\\netico\\Bones\\SQLite\u003A\u003A\u0024data",
            "name": "data",
            "summary": "This\u0020array\u0020contains\u0020the\u0020results\u0020of\u0020the\u0020query.",
            "url": "classes/netico-Bones-SQLite.html#property_data"
        },                {
            "fqsen": "\\netico\\Bones\\Template",
            "name": "Template",
            "summary": "This\u0020basic\u0020template\u0020system\u0020gets\u0020you\u0020off\u0020to\u0020a\u0020start.",
            "url": "classes/netico-Bones-Template.html"
        },                {
            "fqsen": "\\netico\\Bones\\Template\u003A\u003A__construct\u0028\u0029",
            "name": "__construct",
            "summary": "It\u0020requires\u0020the\u0020path\u0020to\u0020the\u0020template\u0020file.",
            "url": "classes/netico-Bones-Template.html#method___construct"
        },                {
            "fqsen": "\\netico\\Bones\\Template\u003A\u003Aadd\u0028\u0029",
            "name": "add",
            "summary": "The\u0020method\u0020adds\u0020a\u0020variable\u0020to\u0020the\u0020template.",
            "url": "classes/netico-Bones-Template.html#method_add"
        },                {
            "fqsen": "\\netico\\Bones\\Template\u003A\u003Asection\u0028\u0029",
            "name": "section",
            "summary": "This\u0020method\u0020provides\u0020support\u0020for\u0020repeating\u0020sections.",
            "url": "classes/netico-Bones-Template.html#method_section"
        },                {
            "fqsen": "\\netico\\Bones\\Template\u003A\u003Aoutput\u0028\u0029",
            "name": "output",
            "summary": "This\u0020method\u0020prints\u0020the\u0020HTML\u0020code.",
            "url": "classes/netico-Bones-Template.html#method_output"
        },                {
            "fqsen": "\\netico\\Bones\\Template\u003A\u003Ars\u0028\u0029",
            "name": "rs",
            "summary": "This\u0020method\u0020also\u0020provides\u0020support\u0020for\u0020repeating\u0020sections.",
            "url": "classes/netico-Bones-Template.html#method_rs"
        },                {
            "fqsen": "\\CONFIG",
            "name": "CONFIG",
            "summary": "Path\u0020to\u0020the\u0020configuration\u0020file.",
            "url": "namespaces/default.html#constant_CONFIG"
        },                {
            "fqsen": "\\TEMPLATES",
            "name": "TEMPLATES",
            "summary": "Path\u0020to\u0020the\u0020folder\u0020that\u0020contains\u0020the\u0020templates.",
            "url": "namespaces/default.html#constant_TEMPLATES"
        },                {
            "fqsen": "\\",
            "name": "\\",
            "summary": "",
            "url": "namespaces/default.html"
        },                {
            "fqsen": "\\netico\\Bones",
            "name": "Bones",
            "summary": "",
            "url": "namespaces/netico-bones.html"
        },                {
            "fqsen": "\\netico",
            "name": "netico",
            "summary": "",
            "url": "namespaces/netico.html"
        }            ]
);
