<?php

/**
 * Error reporting setup and loading of Classes and Constants.
 *
 * @package bones
 * @link https://git.lattuga.net/netico/code-library/src/master/Framework
 * @copyright Copyright (c) 2016, 2022 netico <netico@riseup.net>
 * @license https://www.gnu.org/licenses/gpl-3.0.en.html GNU General Public License
 * @author netico <netico@riseup.net>
 */

 // Error reporting
ini_set('display_errors', '1');
ini_set('xdebug.scream', '1');
error_reporting(E_ALL);

// Constants
require __DIR__ . "/constants.php";

// Classes
require __DIR__ . "/Configuration.php";
require __DIR__ . "/SQLite.php";
require __DIR__ . "/Template.php";
require __DIR__ . "/Obfuscation.php";
